package com.io.yutian.thewardungeon;

import com.io.yutian.thewardungeon.command.DungeonCommand;
import com.io.yutian.thewardungeon.config.CommonConfig;
import com.io.yutian.thewardungeon.dungeon.Dungeon;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.hook.PluginHook;
import com.io.yutian.thewardungeon.lang.Lang;
import com.io.yutian.thewardungeon.listener.DungeonListener;
import com.io.yutian.thewardungeon.listener.ObjectiveListener;
import com.io.yutian.thewardungeon.manager.DungeonManager;
import com.io.yutian.thewardungeon.manager.MapManager;
import com.io.yutian.thewardungeon.manager.RegistryManager;
import com.io.yutian.thewardungeon.papi.DungeonPAPI;
import com.io.yutian.thewarskyblocklib.gui.GuiListener;
import com.io.yutian.thewarskyblocklib.manager.CommandManager;
import com.io.yutian.thewarskyblocklib.util.FileUtil;
import org.bukkit.Bukkit;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;

public final class TheWarDungeon extends JavaPlugin {

    private static final String PERSION = "1.0beta";

    private static TheWarDungeon instance;

    @Override
    public void onEnable() {
        instance = this;

        PluginHook.hook();
        RegistryManager.init();
        CommonConfig.init();
        DungeonCommand.init();
        Lang.reload();
        MapManager.load();
        DungeonManager.load();

        registerListener();

        checkWorldFile();

        new DungeonPAPI().register();

    }

    @Override
    public void onDisable() {

        CommandManager.unregisterAll();

        for (Dungeon dungeon : DungeonManager.getDungeons()) {
            for (DungeonInstance dungeonInstance : dungeon.getQueue().getAllDungeonInstance()) {
                dungeonInstance.getWorldInstance().remove();
            }
        }

        //checkWorldFile();

    }

    private void checkWorldFile() {
        File path = new File(System.getProperty("user.dir"));
        for (File file : path.listFiles()) {
            if (file.isDirectory() && file.getName().startsWith("dw_")) {
                File file1 = new File(file+File.separator+"dungeonworld.token");
                if (file1.exists()) {
                    FileUtil.removeDir(file);
                }
            }
        }
    }

    private void registerListener() {
        Bukkit.getPluginManager().registerEvents(new DungeonListener(), this);
        Bukkit.getPluginManager().registerEvents(new ObjectiveListener(), this);
        Bukkit.getPluginManager().registerEvents(new GuiListener(), this);
    }

    public static TheWarDungeon inst() {
        return instance;
    }

}
