package com.io.yutian.thewardungeon.command.list;

import com.io.yutian.thewardungeon.TheWarDungeon;
import com.io.yutian.thewardungeon.dungeon.Dungeon;
import com.io.yutian.thewardungeon.dungeon.config.DungeonConfig;
import com.io.yutian.thewardungeon.lang.Lang;
import com.io.yutian.thewardungeon.manager.DungeonManager;
import com.io.yutian.thewarskyblocklib.command.CommandContext;
import com.io.yutian.thewarskyblocklib.command.ICommand;
import com.io.yutian.thewarskyblocklib.command.argument.Argument;
import com.io.yutian.thewarskyblocklib.command.argument.ArgumentTypes;
import com.io.yutian.thewarskyblocklib.util.FileUtil;
import net.kyori.adventure.text.Component;
import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.command.CommandSender;

import java.io.File;

public class CommandCreate extends ICommand {

    public CommandCreate() {
        super("create");
        addArgument(Argument.argument("id", ArgumentTypes.STRING));
        addArgument(Argument.argument("world", ArgumentTypes.STRING));
    }

    @Override
    public void executes(CommandContext commandContext) {
        CommandSender sender = commandContext.getSender();
        String id = commandContext.getArgumentsValue("id").getString();
        String worldName = commandContext.getArgumentsValue("world").getString();
        if (DungeonManager.getDungeon(id) != null) {
            sender.sendMessage(Component.text(Lang.prefix+"§c副本 "+id+" 已存在"));
            return;
        }
        File folder = new File(DungeonManager.MAIN_FOLDER, id);
        File worldFolder = new File(TheWarDungeon.inst().getDataFolder()+File.separator+"maps"+File.separator+worldName);
        boolean copy = !worldFolder.exists();
        World world = Bukkit.getWorld(worldName);
        if (world != null) {
            if (world.getPlayerCount() > 0) {
                sender.sendMessage(Component.text(Lang.prefix+"§c世界"+worldName+"已加载且世界内有玩家,请先卸载世界"));
                return;
            }
            sender.sendMessage(Component.text(Lang.prefix+"§c世界"+worldName+"已加载,请先卸载世界"));
            return;
        }
        sender.sendMessage(Component.text(Lang.prefix+"§e正在创建副本..."));
        if (copy) {
            worldFolder.mkdirs();
            File importMapFolder = new File(worldName);
            FileUtil.copyDir(importMapFolder, worldFolder, "advancements", "DIM1", "DIM-1", "data", "datapacks", "playerdata", "stats", "paper-world.yml", "uid.dat", "icon.png", "serverconfig");
        }
        if (folder.exists()) {
            folder.mkdirs();
        }
        DungeonConfig dungeonConfig = new DungeonConfig(worldName, folder);
        dungeonConfig.initConfig();
        Dungeon dungeon = new Dungeon(id, dungeonConfig);
        DungeonManager.registerDungeon(id, dungeon);
        sender.sendMessage(Component.text(Lang.prefix+"§a成功创建副本 §b"+id));
    }

}
