package com.io.yutian.thewardungeon.command.list;

import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.dungeon.player.DungeonPlayer;
import com.io.yutian.thewardungeon.dungeon.player.PlayerState;
import com.io.yutian.thewardungeon.manager.DungeonManager;
import com.io.yutian.thewarskyblocklib.command.CommandContext;
import com.io.yutian.thewarskyblocklib.command.ICommand;
import com.io.yutian.thewarskyblocklib.command.argument.Argument;
import com.io.yutian.thewarskyblocklib.command.argument.ArgumentTypes;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.UUID;

public class CommandDungeonEvent extends ICommand {

    public CommandDungeonEvent() {
        super("dungeonevent");
        addArgument(Argument.argument("uuid", ArgumentTypes.UUID));
        addArgument(Argument.argument("event", ArgumentTypes.STRING));
    }

    @Override
    public void executes(CommandContext commandContext) {
        Player player = (Player) commandContext.getSender();
        UUID uuid = commandContext.getArgumentsValue("uuid").getUUID();
        String event = commandContext.getArgumentsValue("event").getString();
        if (!uuid.equals(player.getUniqueId())) {
            return;
        }
        if (event.equalsIgnoreCase("respawn")) {
            DungeonInstance dungeonInstance = DungeonManager.getDungeonInstance(player);
            DungeonPlayer dungeonPlayer = dungeonInstance.getPlayer(player);
            if (dungeonPlayer == null || !dungeonPlayer.getState().equals(PlayerState.DEAD)) {
                return;
            }
            dungeonInstance.respawn(dungeonPlayer);
        }
    }

    @Override
    public boolean hide() {
        return true;
    }

    @Override
    public boolean hasPermission(CommandSender sender) {
        return sender instanceof Player;
    }

}
