package com.io.yutian.thewardungeon.command.list;

import com.io.yutian.thewardungeon.dungeon.Dungeon;
import com.io.yutian.thewardungeon.lang.Lang;
import com.io.yutian.thewardungeon.manager.DungeonManager;
import com.io.yutian.thewarskyblocklib.command.CommandContext;
import com.io.yutian.thewarskyblocklib.command.ICommand;
import com.io.yutian.thewarskyblocklib.command.argument.Argument;
import com.io.yutian.thewarskyblocklib.command.argument.ArgumentTypes;
import com.io.yutian.thewarskyblocklib.command.argument.Suggests;
import net.kyori.adventure.text.Component;
import org.bukkit.command.CommandSender;

import java.io.File;

public class CommandState extends ICommand {

    public CommandState() {
        super("state");
        addArgument(Argument.argument("id", ArgumentTypes.STRING).suggest(Suggests.DUNGEON_LIST));
    }

    @Override
    public void executes(CommandContext commandContext) {
        CommandSender sender = commandContext.getSender();
        String id = commandContext.getArgumentsValue("id").getString();
        Dungeon dungeon = DungeonManager.getDungeon(id);
        if (dungeon == null) {
            sender.sendMessage(Component.text(Lang.prefix+"§c副本 "+id+" 不存在"));
            return;
        }
        sender.sendMessage(Component.text("§7---------- §8[§9"+id+"§8]§7----------"));
        sender.sendMessage(Component.text("§aId: §f"+id));
        sender.sendMessage(Component.text("§a文件目录: §f"+"plugins"+File.separator+"TheWarDungeon"+File.separator+"dungeons"+File.separator+id));
        sender.sendMessage(Component.text("§a实例数量: §f"+dungeon.getQueue().size()));
        sender.sendMessage(Component.text("§a空闲房间数量: §f"+dungeon.getQueue().getAllFreeDungeonInstance().size()));
        sender.sendMessage(Component.text("§7---------- §8[§9"+id+"§8]§7----------"));
    }
}
