package com.io.yutian.thewardungeon.dungeon.condition;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.hook.PluginHook;
import com.io.yutian.thewardungeon.util.JSUtil;
import com.io.yutian.thewardungeon.util.Log;
import me.clip.placeholderapi.PlaceholderAPI;
import org.bukkit.ChatColor;
import org.bukkit.entity.Player;

public class Condition extends ICondition {

    private String text;
    private String message;

    public Condition(LineMetadata metadata) {
        super(metadata);
        this.text = metadata.getString("text", null);
        this.message = metadata.getString("message", null);
    }

    @Override
    public boolean isValid(Player player) {
        if (text == null) {
            Log.warning("运行条件时出现错误!");
            Log.warning("脚本: "+metadata.getSource());
            Log.warning("原因: text 参数错误");
            return false;
        }
        if (message == null) {
            Log.warning("运行条件时出现错误!");
            Log.warning("脚本: "+metadata.getSource());
            Log.warning("原因: message 参数错误");
            return false;
        }
        String s = text;
        if (PluginHook.isHookPlaceholderAPI()) {
            s = PlaceholderAPI.setPlaceholders(player, s);
        }
        try {
            Object result = JSUtil.eval(s);
            if (!(result instanceof Boolean)) {
                Log.warning("运行条件时出现错误!");
                Log.warning("脚本: "+metadata.getSource());
                Log.warning("原因: JS条件结果非布尔值");
                return false;
            }
            boolean r = (Boolean) result;
            if (!r) {
                String m = ChatColor.translateAlternateColorCodes('&', message);
                player.sendMessage(m);
            }
            return r;
        } catch (Exception e) {
            return false;
        }
    }

}
