package com.io.yutian.thewardungeon.dungeon.condition;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.script.SelectorType;
import com.io.yutian.thewardungeon.util.ConsoleColor;
import com.io.yutian.thewardungeon.util.Log;
import javassist.bytecode.Opcode;
import org.bukkit.entity.Player;

import java.lang.reflect.Constructor;
import java.util.HashMap;
import java.util.Map;

public abstract class ICondition {

    public LineMetadata metadata;

    public ICondition(LineMetadata metadata) {
        this.metadata = metadata;
    }

    public abstract boolean isValid(Player player);

    public static ICondition getCondition(String arg) {
        String key;
        String s = arg.toLowerCase();
        if (s.contains("{")) {
            key = s.substring(0, s.indexOf("{"));
        } else if (s.contains("[")) {
            key = s.substring(0, s.indexOf("["));
        } else {
            key = s;
        }
        Map<String, String> valueMap = new HashMap<>();
        String s2 = arg;
        SelectorType selectorType1 = SelectorType.NULL;
        if (s2.contains("{") && s2.contains("}")) {
            int count = 0;
            String s3 = s2.substring(s2.indexOf(Opcode.LSHR) + 1, s2.lastIndexOf(Opcode.LUSHR));
            char[] charArray = s3.toCharArray();
            int length = charArray.length;
            for (int i = 0; i < length; i++) {
                char c = charArray[i];
                count = c == '{' ? count + 1 : count;
                if (c == '}') {
                    count--;
                }
            }
            if (count != 0) {
                Log.error(ConsoleColor.RED + "加载条件时发生错误: 不平衡支撑" + ConsoleColor.WHITE);
                Log.error(ConsoleColor.RED + "[Line]: " + ConsoleColor.WHITE + s3);
            } else if (s3.length() != 0) {
                int start = 0;
                int pos = 0;
                int depth = 0;
                String s4 = s3 + "}";
                char[] charArray2 = s4.toCharArray();
                int length2 = charArray2.length;
                for (int i2 = 0; i2 < length2; i2++) {
                    char c2 = charArray2[i2];
                    depth = (c2 == '}' || c2 == ']') ? ((c2 == '{' || c2 == '[') ? depth + 1 : depth) - 1 : depth;
                    if ((c2 == ';' && depth == 0) || (c2 == '}' && depth < 0)) {
                        try {
                            String element = s4.substring(start, pos);
                            if (pos - start > 0 && element.length() > 0) {
                                valueMap.put(element.substring(0, element.indexOf(61)).trim().toLowerCase(), element.substring(element.indexOf(61) + 1).trim());
                            }
                            start = pos + 1;
                        } catch (Exception e) {
                            start = pos + 1;
                        } catch (Throwable th) {
                            int i3 = pos + 1;
                            throw th;
                        }
                    }
                    pos++;
                }
            }
        } else if (!s2.contains("[") || !s2.contains("]")) {
            key = s2;
        } else {
            try {
                s2 = s2.split("\\[")[1].split("\\]")[0];
            } catch (ArrayIndexOutOfBoundsException e2) {
                Log.error(ConsoleColor.RED + "加载条件时发生错误: 无效语法" + ConsoleColor.WHITE);
                Log.error(ConsoleColor.RED + "[Line]: " + ConsoleColor.WHITE + s2);
            }
        }

        key = key.toLowerCase();
        if (!key.equalsIgnoreCase("condition")) {
            Log.error(ConsoleColor.RED + "加载条件时发生错误: 无效条件" + ConsoleColor.WHITE);
            Log.error(ConsoleColor.RED + "[Line]: " + ConsoleColor.WHITE + key);
            return null;
        }
        try {
            Constructor constructor = Condition.class.getConstructor(LineMetadata.class);
            ICondition condition = (ICondition) constructor.newInstance(new LineMetadata(arg, valueMap));
            return condition;
        } catch (Exception e) {
            Log.error(ConsoleColor.RED + "加载条件时发生错误: 未知错误" + ConsoleColor.WHITE);
            Log.error(ConsoleColor.RED + "[Line]: " + ConsoleColor.WHITE + key);
            e.printStackTrace();
            return null;
        }
    }

}
