package com.io.yutian.thewardungeon.dungeon.config;

import org.bukkit.GameMode;
import org.bukkit.configuration.ConfigurationSection;

public class DungeonOption {

    private int maxInstance;

    private int min;
    private int max;

    private int lobbyWaitTime;

    private GameMode gameMode;

    private boolean revive;
    private int reviveAmount;
    private int reviveTime;

    private boolean breakBlock;
    private boolean placeBlock;

    private boolean pvp;

    public DungeonOption() {
    }

    public void load(ConfigurationSection configurationSection) {
        maxInstance = configurationSection.getInt("maxInstance", 10);
        min = configurationSection.getInt("min", 1);
        max = configurationSection.getInt("max", 8);
        lobbyWaitTime = configurationSection.getInt("lobbyWaitTime", 60);
        gameMode = GameMode.valueOf(configurationSection.getString("gamemode", GameMode.ADVENTURE.toString()));
        revive = configurationSection.getBoolean("revive", true);
        reviveAmount = configurationSection.getInt("reviveAmount", -1);
        reviveTime = configurationSection.getInt("reviveTime", 10);
        breakBlock = configurationSection.getBoolean("breakBlock", false);
        placeBlock = configurationSection.getBoolean("placeBlock", false);
        pvp = configurationSection.getBoolean("pvp", false);
    }

    public int getMaxInstance() {
        return maxInstance;
    }

    public int getMin() {
        return min;
    }

    public int getMax() {
        return max;
    }

    public int getLobbyWaitTime() {
        return lobbyWaitTime;
    }

    public GameMode getGameMode() {
        return gameMode;
    }

    public boolean isRevive() {
        return revive;
    }

    public int getReviveAmount() {
        return reviveAmount;
    }

    public int getReviveTime() {
        return reviveTime;
    }

    public boolean isBreakBlock() {
        return breakBlock;
    }

    public boolean isPlaceBlock() {
        return placeBlock;
    }

    public boolean isPVP() {
        return pvp;
    }

}
