package com.io.yutian.thewardungeon.dungeon.objective;

import com.io.yutian.thewardungeon.script.Script;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class ObjectiveGourp {

    private final UUID uuid = UUID.randomUUID();

    private List<Objective> objectives = new ArrayList<>();
    private List<Script> scripts = new ArrayList<>();

    public ObjectiveGourp(List<Objective> objectives, List<Script> scripts) {
        this.objectives = objectives;
        this.scripts = scripts;
    }

    public <O extends Objective> List<O> getObjectives(Class<O> oClass) {
        List<O> objectives1 = new ArrayList<>();
        objectives.forEach(objective -> {
            if (objective.getClass().equals(oClass)) {
                objectives1.add((O) objective);
            }
        });
        return objectives1;
    }

    public UUID getUUID() {
        return uuid;
    }

    public List<Objective> getObjectives() {
        return objectives;
    }

    public List<Script> getScripts() {
        return scripts;
    }

    public ObjectiveGourp clone() {
        List<Objective> objectives1 = new ArrayList<>();
        objectives.forEach(objective -> objectives1.add(objective.clone()));
        List<Script> scripts1 = new ArrayList<>();
        scripts.forEach(script -> scripts1.add(script.clone()));
        return new ObjectiveGourp(objectives1, scripts1);
    }

}
