package com.io.yutian.thewardungeon.dungeon.objective.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.dungeon.objective.Objective;
import com.io.yutian.thewardungeon.util.LineMetadataUtil;
import com.io.yutian.thewardungeon.util.LogUtil;
import com.io.yutian.thewarskyblocklib.math.Point;
import org.bukkit.entity.Player;

public class LocationObjective extends Objective {

    private Point location;
    private double range;

    public LocationObjective(LineMetadata metadata) {
        super(metadata);
        this.location = LineMetadataUtil.readPoint(metadata, "location", null);
        this.range = metadata.getDouble("range", 1.0);
        setMaxProgress(1);
    }

    public boolean isArrive(DungeonInstance dungeonInstance, Player player) {
        if (location == null) {
            LogUtil.logObjective(dungeonInstance, metadata, LocationObjective.class, "坐标参数错误");
            return false;
        }
        if (range <= 0) {
            LogUtil.logObjective(dungeonInstance, metadata, LocationObjective.class, "范围参数错误,必须大于0");
            return false;
        }
        return location.toLocation(dungeonInstance.getWorldInstance().getWorld()).distanceSquared(player.getLocation()) <= range;
    }

}
