package com.io.yutian.thewardungeon.dungeon.objective.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.dungeon.objective.Objective;
import com.io.yutian.thewardungeon.util.LineMetadataUtil;
import com.io.yutian.thewardungeon.util.LogUtil;
import com.io.yutian.thewarskyblocklib.math.Point;
import com.io.yutian.thewarskyblocklib.region.Region;
import org.bukkit.entity.Player;

public class RegionObjective extends Objective {

    private Point start;
    private Point end;

    protected Region region;

    public RegionObjective(LineMetadata metadata) {
        super(metadata);
        this.start = LineMetadataUtil.readPoint(metadata, "start", null);
        this.end = LineMetadataUtil.readPoint(metadata, "end", null);
        setMaxProgress(1);
    }

    public boolean isInRegion(DungeonInstance dungeonInstance, Player player) {
        if (start == null) {
            LogUtil.logObjective(dungeonInstance, metadata, RegionObjective.class, "开始坐标参数错误");
            return false;
        }
        if (end == null) {
            LogUtil.logObjective(dungeonInstance, metadata, RegionObjective.class, "结束坐标参数错误");
            return false;
        }
        if (region == null) {
            this.region = new Region(dungeonInstance.getWorldInstance().getWorld(), start, end);
        }
        return region.isInRegion(player.getLocation());
    }

}
