package com.io.yutian.thewardungeon.dungeon.objective.list;

import com.io.yutian.thewardungeon.TheWarDungeon;
import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.dungeon.DungeonState;
import com.io.yutian.thewardungeon.dungeon.objective.Objective;
import com.io.yutian.thewardungeon.util.LogUtil;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;

public class TimeObjective extends Objective {

    private int time;

    public TimeObjective(LineMetadata metadata) {
        super(metadata);
        this.time = metadata.getInt("time", 72000);
        setMaxProgress(time);
    }

    public BukkitTask createTask(DungeonInstance dungeonInstance) {
        if (time <= 0) {
            LogUtil.logObjective(dungeonInstance, metadata, TimeObjective.class, "时间参数错误,必须大于0");
            return null;
        }
        BukkitTask task = new BukkitRunnable() {
            @Override
            public void run() {
                if (dungeonInstance.isOverdue() || dungeonInstance.getState().equals(DungeonState.END)) {
                    cancel();
                    return;
                }
                TimeObjective.this.setProgress(time);
                dungeonInstance.checkObjectiveGroup();
            }
        }.runTaskLater(TheWarDungeon.inst(), time);
        return task;
    }

}
