package com.io.yutian.thewardungeon.dungeon.player;

import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.lang.Lang;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.event.ClickEvent;
import org.bukkit.GameMode;
import org.bukkit.entity.Player;

public class DungeonPlayer {

    private final Player player;

    private PlayerState state = PlayerState.LIVING;

    private GameMode gameMode;

    private int death = 0;

    public DungeonPlayer(Player player) {
        this.player = player;
        setGameMode(player.getGameMode());
    }

    public void setGameMode(GameMode gameMode) {
        this.gameMode = gameMode;
    }

    public void setState(PlayerState state) {
        this.state = state;
    }

    public PlayerState getState() {
        return state;
    }

    public void sendRespawnMessage(DungeonInstance dungeonInstance) {
        Component component1 = Component.text(Lang.get("dungeon.respawn.message_1", (dungeonInstance.getDungeon().getConfig().getOption().getReviveAmount() == -1 ? "无限" : dungeonInstance.getDungeon().getConfig().getOption().getReviveAmount() - death), dungeonInstance.getDungeon().getConfig().getOption().getReviveTime()) + " ");
        Component component2 = Component.text(Lang.get("dungeon.respawn.message_2")).clickEvent(ClickEvent.clickEvent(ClickEvent.Action.RUN_COMMAND, "/dungeon dungeonevent " + player.getUniqueId() + " respawn"));
        Component component3 = Component.text(Lang.get("dungeon.respawn.message_3")).clickEvent(ClickEvent.clickEvent(ClickEvent.Action.RUN_COMMAND, "/dungeon leave"));
        Component main = component1.append(component2).append(Component.text(" ")).append(component3);
        player.sendMessage(main);
    }

    public void sendDeathMessage() {
        player.sendMessage(Component.text(Lang.get("dungeon.respawn.death")));
    }

    public void addDeath(int death) {
        this.death += death;
    }

    public void setDeath(int death) {
        this.death = death;
    }

    public Player getPlayer() {
        return player;
    }

    public GameMode getGameMode() {
        return gameMode;
    }

    public int getDeath() {
        return death;
    }

}
