package com.io.yutian.thewardungeon.dungeon.world;

import org.bukkit.Bukkit;
import org.bukkit.World;

import java.io.File;
import java.util.UUID;

public class WorldInstance {

    private UUID uuid;

    private File folder;
    private World world;

    private boolean occupied = false;

    protected boolean destroyed = false;

    public WorldInstance(File folder, World world, UUID uuid) {
        this.folder = folder;
        this.world = world;
        this.uuid = uuid;
    }

    public File getFolder() {
        return folder;
    }

    public World getWorld() {
        return world;
    }

    public UUID getUUID() {
        return uuid;
    }

    public boolean isOccupied() {
        return occupied;
    }

    public void setOccupied(boolean occupied) {
        this.occupied = occupied;
    }

    public void remove() {
        if (destroyed) {
            return;
        }
        destroyed = true;
        unloadWorld();
        /*
        Bukkit.getScheduler().runTaskLater(TheWarDungeon.inst(), ()->{
            try {
                FileUtils.deleteDirectory(folder);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }, 10L);
         */
    }

    private void unloadWorld() {
        if (world != null) {
            Bukkit.unloadWorld(world, false);
        }
    }

    public boolean isDestroyed() {
        return destroyed;
    }

}
