package com.io.yutian.thewardungeon.hook;

import com.comphenix.protocol.ProtocolLibrary;
import com.comphenix.protocol.ProtocolManager;
import com.io.yutian.thewardungeon.hook.papi.DungeonExpansion;
import net.luckperms.api.LuckPerms;
import net.milkbowl.vault.economy.Economy;
import net.milkbowl.vault.permission.Permission;
import org.bukkit.Bukkit;
import org.bukkit.plugin.RegisteredServiceProvider;

public class PluginHook {

    private static boolean hookPlaceholderAPI = false;
    private static boolean hookProtocolLib = false;
    private static boolean hookVault = false;
    private static boolean hookLuckPerms = false;

    private static ProtocolManager protocolManager;
    private static Permission permission;
    private static Economy economy;
    private static LuckPerms luckPerms;

    public static void hook() {

        if (Bukkit.getPluginManager().isPluginEnabled("PlaceholderAPI")) {
            hookPlaceholderAPI = true;
            new DungeonExpansion().register();
        }
        if (Bukkit.getPluginManager().isPluginEnabled("ProtocolLib")) {
            hookProtocolLib = true;
            protocolManager = ProtocolLibrary.getProtocolManager();
        }
        if (Bukkit.getPluginManager().isPluginEnabled("Vault")) {
            hookVault = true;
            RegisteredServiceProvider<Permission> permissionProvider = Bukkit.getServer().getServicesManager().getRegistration(Permission.class);
            if (permissionProvider != null) {
                permission = permissionProvider.getProvider();
            }

            RegisteredServiceProvider<Economy> economyProvider = Bukkit.getServer().getServicesManager().getRegistration(Economy.class);
            if (economyProvider != null) {
                economy = economyProvider.getProvider();
            }
        }
        if (Bukkit.getPluginManager().isPluginEnabled("LuckPerms")) {
            hookLuckPerms = true;
            luckPerms = Bukkit.getServicesManager().load(LuckPerms.class);
        }
    }

    public static boolean isHookPlaceholderAPI() {
        return hookPlaceholderAPI;
    }

    public static boolean isHookProtocolLib() {
        return hookProtocolLib;
    }

    public static boolean isHookVault() {
        return hookVault;
    }

    public static boolean isHookLuckPerms() {
        return hookLuckPerms;
    }

    public static ProtocolManager getProtocolManager() {
        return protocolManager;
    }

    public static Permission getPermission() {
        return permission;
    }

    public static Economy getEconomy() {
        return economy;
    }

    public static LuckPerms getLuckPerms() {
        return luckPerms;
    }

}
