package com.io.yutian.thewardungeon.manager;

import com.io.yutian.thewardungeon.TheWarDungeon;
import com.io.yutian.thewardungeon.dungeon.Dungeon;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.dungeon.config.DungeonConfig;
import org.bukkit.World;
import org.bukkit.entity.Player;

import java.io.File;
import java.util.*;

public class DungeonManager {

    public static final File MAIN_FOLDER = new File(TheWarDungeon.inst().getDataFolder()+File.separator+"dungeons");

    private static Map<String, Dungeon> dungeons = new HashMap<>();

    public static void load() {
        dungeons.clear();
        File path = MAIN_FOLDER;
        if (!path.exists()) {
            path.mkdirs();
        }
        for (File file : path.listFiles()) {
            if (!file.isDirectory()) {
                continue;
            }
            String id = file.getName();
            DungeonConfig dungeonConfig = new DungeonConfig(file);
            Dungeon dungeon = new Dungeon(id, dungeonConfig);
            dungeons.put(id, dungeon);
        }
    }

    public static Dungeon getDungeon(World world) {
        for (Dungeon dungeon : dungeons.values()) {
            for (DungeonInstance dungeonInstance : dungeon.getQueue().getAllDungeonInstance()) {
                if (dungeonInstance.getWorldInstance().getWorld().getName().equals(world.getName())) {
                    return dungeon;
                }
            }
        }
        return null;
    }

    public static DungeonInstance getDungeonInstance(World world) {
        for (Dungeon dungeon : dungeons.values()) {
            for (DungeonInstance dungeonInstance : dungeon.getQueue().getAllDungeonInstance()) {
                if (dungeonInstance.getWorldInstance().getWorld().getName().equals(world.getName())) {
                    return dungeonInstance;
                }
            }
        }
        return null;
    }

    public static DungeonInstance getDungeonInstance(Player player) {
        for (Dungeon dungeon : dungeons.values()) {
            for (DungeonInstance dungeonInstance : dungeon.getQueue().getAllDungeonInstance()) {
                if (dungeonInstance.getPlayer(player) != null) {
                    return dungeonInstance;
                }
            }
        }
        return null;
    }

    public static Dungeon getDungeon(String id) {
        return dungeons.get(id);
    }

    public static Collection<Dungeon> getDungeons() {
        return dungeons.values();
    }

    public static void registerDungeon(String id, Dungeon dungeon) {
        if (dungeons.containsKey(id)) {
            return;
        }
        dungeons.put(id, dungeon);
    }

}
