package com.io.yutian.thewardungeon.manager;

import com.io.yutian.thewardungeon.TheWarDungeon;
import com.io.yutian.thewardungeon.dungeon.DungeonMap;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

public class MapManager {

    private static Map<String, DungeonMap> dungeonMaps = new HashMap<>();

    public static void load() {
        dungeonMaps.clear();
        File path = new File(TheWarDungeon.inst().getDataFolder()+File.separator+"maps");
        if (!path.exists()) {
            path.mkdirs();
        }
        for (File file : path.listFiles()) {
            if (!file.isDirectory()) {
                continue;
            }
            String id = file.getName();
            dungeonMaps.put(id, new DungeonMap(id, file));
        }
    }

    public static DungeonMap getDungeonMap(String id) {
        return dungeonMaps.get(id);
    }

    public static Map<String, DungeonMap> getDungeonMaps() {
        return dungeonMaps;
    }

}
