package com.io.yutian.thewardungeon.manager;

import com.io.yutian.thewardungeon.dungeon.objective.list.KillMobObjective;
import com.io.yutian.thewardungeon.dungeon.objective.Objective;
import com.io.yutian.thewardungeon.dungeon.objective.list.LocationObjective;
import com.io.yutian.thewardungeon.dungeon.objective.list.RegionObjective;
import com.io.yutian.thewardungeon.dungeon.objective.list.TimeObjective;
import com.io.yutian.thewardungeon.script.Script;
import com.io.yutian.thewardungeon.script.list.*;
import com.io.yutian.thewarskyblocklib.registry.Registry;

public class RegistryManager {

    private static Registry<String, Class<? extends Script>> scriptRegistry = new Registry<>();
    private static Registry<String, Class<? extends Objective>> objectiveRegistry = new Registry<>();

    public static void init() {
        registerScript();
        registerObjective();
    }

    private static void registerScript() {
        scriptRegistry.add("stop", StopScript.class);
        scriptRegistry.add("message", MessageScript.class);
        scriptRegistry.add("teleport", TeleportScript.class);
        scriptRegistry.add("time", TimeScript.class);
        scriptRegistry.add("weather", WeatherScript.class);
        scriptRegistry.add("spawnmob", SpawnMobScript.class);
        scriptRegistry.add("addobjective", AddObjectiveScript.class);
        scriptRegistry.add("setblock", SetBlockScript.class);
        scriptRegistry.add("fillblock", FillBlockScript.class);
        scriptRegistry.add("kill", KillScript.class);
        scriptRegistry.add("command", CommandScript.class);
        scriptRegistry.add("setrespawn", SetRespawnScript.class);
        scriptRegistry.add("sound", SoundScript.class);
        scriptRegistry.add("title", TitleScript.class);
        scriptRegistry.add("settotalcountdown", SetTotalCountdownScript.class);
        scriptRegistry.add("setcountdown", SetCountdownScript.class);
    }

    private static void registerObjective() {
        objectiveRegistry.add("time", TimeObjective.class);
        objectiveRegistry.add("killmob", KillMobObjective.class);
        objectiveRegistry.add("location", LocationObjective.class);
        objectiveRegistry.add("region", RegionObjective.class);
    }

    public static Registry<String, Class<? extends Script>> getScriptRegistry() {
        return scriptRegistry;
    }

    public static Registry<String, Class<? extends Objective>> getObjectiveRegistry() {
        return objectiveRegistry;
    }

}