package com.io.yutian.thewardungeon.region;

import com.io.yutian.thewarskyblocklib.math.Point;
import com.io.yutian.thewarskyblocklib.serializa.ConfigSerializable;
import com.io.yutian.thewarskyblocklib.serializa.SerializaUtil;
import com.io.yutian.thewarskyblocklib.serializa.Serializable;
import org.bukkit.configuration.ConfigurationSection;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

public class DungeonRegion implements Serializable<DungeonRegion>, ConfigSerializable {

    private Point min;
    private Point max;

    public DungeonRegion(Point min, Point max) {
        this.min = min;
        this.max = max;
    }

    public Point getMin() {
        return min;
    }

    public Point getMax() {
        return max;
    }

    @Override
    public Map<String, Object> serialize() {
        Map<String, Object> map = new HashMap<>();
        map.put("min", min.serialize());
        map.put("max", max.serialize());
        return map;
    }

    @Override
    public JSONObject toJson() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("min", min.toJson());
        jsonObject.put("max", max.toJson());
        return jsonObject;
    }

    public static DungeonRegion deserialize(ConfigurationSection section) {
        return new DungeonRegion(SerializaUtil.deserialize(Point.class, section.getConfigurationSection("min")), SerializaUtil.deserialize(Point.class, section.getConfigurationSection("max")));
    }

    @Override
    public String toString() {
        return "DungeonRegion{" +
                "min=" + min +
                ", max=" + max +
                '}';
    }

}
