package com.io.yutian.thewardungeon.script;

import com.io.yutian.thewardungeon.TheWarDungeon;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import org.bukkit.Bukkit;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

public class ScriptGourp {

    private final List<Script> scripts;

    public ScriptGourp(List<Script> scripts) {
        this.scripts = scripts;
    }

    public void execute(DungeonInstance dungeonInstance) {
        List<Script> queue = new LinkedList<>();
        scripts.forEach((script -> {
            queue.add(script.clone());
        }));
        execute(queue, dungeonInstance);
    }

    protected void execute(List<Script> queue, DungeonInstance dungeonInstance) {
        if (queue.isEmpty()) {
            return;
        }
        for (int i = 0; i < queue.size(); i++) {
            Script script = queue.get(i);
            if (script == null) {
                continue;
            }
            if (script instanceof Script.DelayScript delayScript) {
                if (i == queue.size()-1) {
                    return;
                }
                int time = delayScript.time;
                List<Script> newQueue = new LinkedList<>();
                for (int k = i+1; k < queue.size(); k++) {
                    Script script1 = queue.get(k);
                    newQueue.add(script1);
                }
                Bukkit.getScheduler().runTaskLater(TheWarDungeon.inst(), ()->{
                    execute(newQueue, dungeonInstance);
                }, time);
                return;
            }
            script.execute(dungeonInstance);
        }
    }

    public ScriptGourp clone() {
        List<Script> scripts1 = new ArrayList<>();
        scripts.forEach(script -> scripts1.add(script.clone()));
        return new ScriptGourp(scripts1);
    }

    @Override
    public String toString() {
        return "ScriptGourp{" +
                "scripts=" + scripts +
                '}';
    }

}
