package com.io.yutian.thewardungeon.script.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.dungeon.objective.ObjectiveGourp;
import com.io.yutian.thewardungeon.script.Script;
import com.io.yutian.thewardungeon.util.LogUtil;

public class AddObjectiveScript extends Script {

    private String objective;

    public AddObjectiveScript(LineMetadata metadata) {
        super(metadata);
        this.objective = metadata.getString("objective", null);
    }

    @Override
    public void execute(DungeonInstance dungeonInstance) {
        if (this.objective == null) {
            LogUtil.logScript(dungeonInstance, metadata, AddObjectiveScript.class, "未知的目标组");
            return;
        }
        ObjectiveGourp gourp = dungeonInstance.getDungeon().getConfig().getObjectiveGourp(objective);
        if (gourp == null) {
            LogUtil.logScript(dungeonInstance, metadata, AddObjectiveScript.class, "未知的目标组");
            return;
        }
        dungeonInstance.addObjectiveGourp(gourp);
    }

}
