package com.io.yutian.thewardungeon.script.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.dungeon.player.DungeonPlayer;
import com.io.yutian.thewardungeon.hook.PluginHook;
import com.io.yutian.thewardungeon.script.Script;
import com.io.yutian.thewardungeon.script.SelectorType;
import com.io.yutian.thewardungeon.util.LogUtil;
import me.clip.placeholderapi.PlaceholderAPI;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.List;

public class CommandScript extends Script {

    private String text;

    public CommandScript(LineMetadata metadata) {
        super(metadata);
        this.text = metadata.getString("text", null);
    }

    @Override
    public void execute(DungeonInstance dungeonInstance) {
        if (text == null) {
            LogUtil.logScript(dungeonInstance, metadata, CommandScript.class, "命令参数为空");
            return;
        }
        List<String> commands = new ArrayList<>();
        if (text.contains(",")) {
            String[] array = text.split(",");
            for (String arg : array) {
                if (arg.startsWith("/")) {
                    commands.add(arg.substring(1));
                } else {
                    commands.add(arg);
                }
            }
        } else {
            if (text.startsWith("/")) {
                commands.add(text.substring(1));
            } else {
                commands.add(text);
            }
        }
        if (selectorType.equals(SelectorType.NULL) || selectorType.equals(SelectorType.SYSTEM)) {
            for (String command : commands) {
                Bukkit.dispatchCommand(Bukkit.getConsoleSender(), command);
            }
        } else if (selectorType.equals(SelectorType.ALL)) {
            for (DungeonPlayer player : dungeonInstance.getPlayers()) {
                Player player1 = player.getPlayer();
                for (String command : commands) {
                    String s1 = command;
                    if (PluginHook.isHookPlaceholderAPI()) {
                        s1 = PlaceholderAPI.setPlaceholders(player1, s1);
                    }
                    Bukkit.dispatchCommand(Bukkit.getConsoleSender(), s1);
                }
            }
        }
    }
}
