package com.io.yutian.thewardungeon.script.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.script.Script;
import com.io.yutian.thewardungeon.util.LogUtil;
import io.lumine.mythic.api.mobs.MythicMob;
import io.lumine.mythic.bukkit.MythicBukkit;
import io.lumine.mythic.core.mobs.ActiveMob;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;

import java.util.Optional;

public class KillScript extends Script {

    private String type;

    public KillScript(LineMetadata metadata) {
        super(metadata);
        this.type = metadata.getString("type", "minecraft:zombie");
    }

    @Override
    public void execute(DungeonInstance dungeonInstance) {
        if (!type.contains(":") || type.startsWith(":") || type.endsWith(":")) {
            LogUtil.logScript(dungeonInstance, metadata, KillScript.class, "实体类型格式错误");
            return;
        }
        String prefix = type.split(":")[0].toLowerCase();
        String type1 = type.split(":")[1];
        if (prefix.equalsIgnoreCase("minecraft")) {
            try {
                EntityType entityType = EntityType.valueOf(type1.toUpperCase());
                for (Entity entity : dungeonInstance.getWorldInstance().getWorld().getEntities()) {
                    if (entity.getType().equals(entityType)) {
                        entity.remove();
                    }
                }
            } catch (Exception e) {
                LogUtil.logScript(dungeonInstance, metadata, KillScript.class, "未知的实体类型");
            }
        } else if (prefix.equalsIgnoreCase("mm") || prefix.equalsIgnoreCase("mythicmob")) {
            Optional<MythicMob> optional = MythicBukkit.inst().getMobManager().getMythicMob(type1);
            if (!optional.isPresent()) {
                LogUtil.logScript(dungeonInstance, metadata, KillScript.class, "未知的实体类型");
                return;
            }
            for (Entity entity : dungeonInstance.getWorldInstance().getWorld().getEntities()) {
                Optional<ActiveMob> optional1 = MythicBukkit.inst().getMobManager().getActiveMob(entity.getUniqueId());
                if (!optional1.isPresent()) {
                    continue;
                }
                ActiveMob activeMob = optional1.get();
                if (activeMob.getMobType().equalsIgnoreCase(type1)) {
                    activeMob.remove();
                }
            }
        } else {
            LogUtil.logScript(dungeonInstance, metadata, KillScript.class, "未知的实体类型");
        }
    }

}
