package com.io.yutian.thewardungeon.script.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.dungeon.player.DungeonPlayer;
import com.io.yutian.thewardungeon.hook.PluginHook;
import com.io.yutian.thewardungeon.script.Script;
import me.clip.placeholderapi.PlaceholderAPI;
import net.kyori.adventure.text.Component;
import org.bukkit.ChatColor;

public class MessageScript extends Script {

    private String message;
    private boolean placeholder = false;

    public MessageScript(LineMetadata metadata) {
        super(metadata);
        this.message = metadata.getString("message", "NULL");
        this.placeholder = metadata.getBoolean("placeholder", false);
    }

    @Override
    public void execute(DungeonInstance dungeonInstance) {
        for (DungeonPlayer player : dungeonInstance.getPlayers()) {
            String m = ChatColor.translateAlternateColorCodes('&', message);
            Component component = Component.text(m);
            if (placeholder && PluginHook.isHookPlaceholderAPI()) {
                component = Component.text(PlaceholderAPI.setPlaceholders(player.getPlayer(), m));
            } else {
                player.getPlayer().sendMessage(component);
            }
        }
    }

}
