package com.io.yutian.thewardungeon.script.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.script.Script;
import com.io.yutian.thewardungeon.util.LineMetadataUtil;
import com.io.yutian.thewardungeon.util.LogUtil;
import com.io.yutian.thewarskyblocklib.math.Point;
import com.io.yutian.thewarskyblocklib.util.EnumUtil;
import org.bukkit.Material;

public class SetBlockScript extends Script {

    private String type;
    private Point location;

    public SetBlockScript(LineMetadata metadata) {
        super(metadata);
        this.type = metadata.getString("type", "STONE").toUpperCase();
        this.location = LineMetadataUtil.readPoint(metadata, "location", null);
    }

    @Override
    public void execute(DungeonInstance dungeonInstance) {
        if (!EnumUtil.isValidEnum(Material.class, type)) {
            LogUtil.logScript(dungeonInstance, metadata, SetBlockScript.class, "方块类型参数错误");
            return;
        }
        if (location == null) {
            LogUtil.logScript(dungeonInstance, metadata, SetBlockScript.class, "坐标参数错误");
            return;
        }
        location.toLocation(dungeonInstance.getWorldInstance().getWorld()).getBlock().setType(Material.valueOf(type));
    }

}
