package com.io.yutian.thewardungeon.script.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.script.Script;
import com.io.yutian.thewardungeon.util.LineMetadataUtil;
import com.io.yutian.thewardungeon.util.LogUtil;
import com.io.yutian.thewarskyblocklib.math.Point;

public class SetRespawnScript extends Script {

    private Point location;

    public SetRespawnScript(LineMetadata metadata) {
        super(metadata);
        location = LineMetadataUtil.readPoint(metadata, "location", null);
    }

    @Override
    public void execute(DungeonInstance dungeonInstance) {
        if (location == null) {
            LogUtil.logScript(dungeonInstance, metadata, SetRespawnScript.class, "坐标参数错误");
            return;
        }
        dungeonInstance.getWorldInstance().getWorld().setSpawnLocation(location.toLocation(dungeonInstance.getWorldInstance().getWorld()));
        dungeonInstance.setSpawnPoint(location);
    }

}
