package com.io.yutian.thewardungeon.script.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.dungeon.player.DungeonPlayer;
import com.io.yutian.thewardungeon.script.Script;
import com.io.yutian.thewardungeon.util.LogUtil;
import com.io.yutian.thewarskyblocklib.util.EnumUtil;
import org.bukkit.Sound;

public class SoundScript extends Script {

    private String type;
    private float volume;
    private float pitch;

    public SoundScript(LineMetadata metadata) {
        super(metadata);
        this.type = metadata.getString("type", Sound.UI_BUTTON_CLICK.toString());
        this.volume = metadata.getFloat("volume", 1.0f);
        this.pitch = metadata.getFloat("pitch", 1.0f);
    }

    @Override
    public void execute(DungeonInstance dungeonInstance) {
        if (!EnumUtil.isValidEnum(Sound.class, type.toUpperCase())) {
            LogUtil.logScript(dungeonInstance, metadata, SoundScript.class, "音效类型参数错误");
            return;
        }
        for (DungeonPlayer player : dungeonInstance.getPlayers()) {
            player.getPlayer().playSound(player.getPlayer().getLocation(), Sound.valueOf(type.toUpperCase()), this.volume, this.pitch);
        }
    }

}
