package com.io.yutian.thewardungeon.script.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.dungeon.player.DungeonPlayer;
import com.io.yutian.thewardungeon.script.Script;
import com.io.yutian.thewardungeon.util.LineMetadataUtil;
import com.io.yutian.thewardungeon.util.LogUtil;
import com.io.yutian.thewarskyblocklib.math.Point;

public class TeleportScript extends Script {

    private Point location;

    public TeleportScript(LineMetadata metadata) {
        super(metadata);
        this.location = LineMetadataUtil.readPoint(metadata, "location", null);
    }

    @Override
    public void execute(DungeonInstance dungeonInstance) {
        if (location == null) {
            LogUtil.logScript(dungeonInstance, metadata, TeleportScript.class, "坐标参数错误");
            return;
        }
        for (DungeonPlayer player : dungeonInstance.getPlayers()) {
            player.getPlayer().teleport(location.toLocation(dungeonInstance.getWorldInstance().getWorld()));
        }
    }

}
