package com.io.yutian.thewardungeon.script.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.script.Script;
import com.io.yutian.thewardungeon.util.LogUtil;

public class TimeScript extends Script {

    private long time;

    public TimeScript(LineMetadata metadata) {
        super(metadata);
        time = metadata.getLong("time", 0);
    }

    @Override
    public void execute(DungeonInstance dungeonInstance) {
        if (time < 0) {
            LogUtil.logScript(dungeonInstance, metadata, TimeScript.class, "时间不得小于0");
            return;
        }
        dungeonInstance.getWorldInstance().getWorld().setTime(time);
    }

}
