package com.io.yutian.thewardungeon.script.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.script.Script;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.title.Title;

import java.time.Duration;

public class TitleScript extends Script {

    private String title;
    private String subtitle;
    private int fadeIn;
    private int stay;
    private int fadeOut;

    public TitleScript(LineMetadata metadata) {
        super(metadata);
        title = metadata.getString("title");
        subtitle = metadata.getString("subtitle");
        fadeIn = metadata.getInt("fade_in");
        stay = metadata.getInt("stay");
        fadeOut = metadata.getInt("fade_out");
    }

    @Override
    public void execute(DungeonInstance dungeonInstance) {
        dungeonInstance.getPlayers().forEach(player -> player.getPlayer().showTitle(Title.title(Component.text(title), Component.text(subtitle), Title.Times.times(Duration.ofMillis(fadeIn * 50), Duration.ofMillis(stay * 50), Duration.ofMillis(fadeOut * 50)))));
    }

}
