package com.io.yutian.thewardungeon.script.list;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.script.Script;
import com.io.yutian.thewardungeon.util.LogUtil;
import org.bukkit.WeatherType;
import org.bukkit.World;

public class WeatherScript extends Script {

    private String weatherType;
    private int time;

    public WeatherScript(LineMetadata metadata) {
        super(metadata);
        weatherType = metadata.getString("type", WeatherType.CLEAR.toString()).toLowerCase();
        time = metadata.getInt("time", Integer.MAX_VALUE);
    }

    @Override
    public void execute(DungeonInstance dungeonInstance) {
        World world = dungeonInstance.getWorldInstance().getWorld();
        if (weatherType.equalsIgnoreCase("clear")) {
            world.setStorm(false);
            world.setThundering(false);
            world.setClearWeatherDuration(time);
        } else if (weatherType.equalsIgnoreCase("storm")) {
            world.setStorm(true);
            world.setThundering(false);
            world.setWeatherDuration(time);
        } else if (weatherType.equalsIgnoreCase("thunder")) {
            world.setStorm(true);
            world.setThundering(true);
            world.setWeatherDuration(time);
        } else {
            LogUtil.logScript(dungeonInstance, metadata, WeatherScript.class, "未知的天气类型");
        }
    }

}
