package com.io.yutian.thewardungeon.util;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewarskyblocklib.math.DirectionPoint;
import com.io.yutian.thewarskyblocklib.math.Point;

public class LineMetadataUtil {

    public static Point readPoint(LineMetadata lineMetadata, String key, Point defaultValue) {
        String arg = lineMetadata.getString(key, null);
        if (arg == null) {
            return defaultValue;
        }
        String[] args = arg.split(",");
        if (args.length < 3) {
            return defaultValue;
        }
        try {
            double x = Double.parseDouble(args[0]);
            double y = Double.parseDouble(args[1]);
            double z = Double.parseDouble(args[2]);
            if (args.length == 5) {
                float yaw = Float.parseFloat(args[3]);
                float pitch = Float.parseFloat(args[4]);
                return new DirectionPoint(x, y, z, yaw, pitch);
            } else if (args.length == 3) {
                return new Point(x, y, z);
            } else {
                return defaultValue;
            }
        } catch (Exception e) {
            return defaultValue;
        }
    }

}
