package com.io.yutian.thewardungeon.util;

import com.io.yutian.thewardungeon.data.LineMetadata;
import com.io.yutian.thewardungeon.dungeon.DungeonInstance;
import com.io.yutian.thewardungeon.dungeon.objective.Objective;
import com.io.yutian.thewardungeon.script.Script;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

public class LogUtil {

    public static Map<UUID, Map<Class<? extends Objective>, Map<String, Long>>> logTimeMap = new HashMap<>();

    public static void logScript(DungeonInstance instance, LineMetadata lineMetadata, Class<? extends Script> scriptType, String arg) {
        Log.warning("执行脚本时出现错误!");
        Log.warning("副本实例: ["+instance.getDungeon().getId()+"] - "+ instance.getUUID());
        Log.warning("脚本: "+lineMetadata.getSource()+"["+scriptType+"]");
        Log.warning("原因: "+arg);
    }

    public static void logObjective(DungeonInstance instance, LineMetadata lineMetadata, Class<? extends Objective> objectiveType, String arg) {
        Log.warning("触发目标任务时出现错误!");
        Log.warning("副本实例: ["+instance.getDungeon().getId()+"] - "+ instance.getUUID());
        Log.warning("目标: "+lineMetadata.getSource()+"["+objectiveType+"]");
        Log.warning("原因: "+arg);
    }

    private static boolean isInCooldown(DungeonInstance dungeonInstance, Class<? extends Objective> objectiveType, String arg) {
        Map<Class<? extends Objective>, Map<String, Long>> map1 = logTimeMap.getOrDefault(dungeonInstance.getUUID(), new HashMap<>());
        Map<String, Long> map2 = map1.getOrDefault(objectiveType, new HashMap<>());
        if (!map2.containsKey(arg)) {
            return false;
        } else {
            long time = map2.get(arg);
            long time1 = System.currentTimeMillis();
            if (time1 - time <= 10*1000L) {
                return false;
            } else {
                map2.put(arg, time1);
                map1.put(objectiveType, map2);
                logTimeMap.put(dungeonInstance.getUUID(), map1);
                return true;
            }
        }
    }

}
