package com.io.yutian.thewarskyblocklib.command;

import org.bukkit.plugin.Plugin;

import java.util.ArrayList;
import java.util.List;

public class Command {

    private final Plugin plugin;
    private final String command;

    private List<String> aliases = new ArrayList<>();

    private final List<ICommand> commands = new ArrayList<>();

    protected boolean frozen = false;

    private Command(Plugin plugin, String command) {
        this.plugin = plugin;
        this.command = command;
    }

    public Command register(ICommand... commandArray) {
        if (frozen) {
            return this;
        }
        for (ICommand iCommand : commandArray) {
            commands.add(iCommand);
        }
        return this;
    }

    public Command addAlias(String... aliases) {
        for (String arg : aliases) {
            this.aliases.add(arg);
        }
        return this;
    }

    public boolean isFrozen() {
        return frozen;
    }

    public void frozen() {
        frozen = true;
    }

    public Plugin getPlugin() {
        return plugin;
    }

    public List<ICommand> getCommands() {
        return commands;
    }

    public String getCommand() {
        return command;
    }

    public List<String> getAliases() {
        return aliases;
    }

    public static Command of(Plugin plugin, String command) {
        return new Command(plugin, command);
    }

}
