package com.io.yutian.thewarskyblocklib.command;

import com.io.yutian.thewarskyblocklib.command.argument.ArgumentValue;
import org.bukkit.command.CommandSender;

import java.util.Map;

public class CommandContext {

    private String commandLabel;
    private String command;
    private CommandSender sender;
    private Map<String, ArgumentValue> argumentsValues;

    public CommandContext(String commandLabel, String command, CommandSender sender, Map<String, ArgumentValue> argumentsValues) {
        this.commandLabel = commandLabel;
        this.command = command;
        this.sender = sender;
        this.argumentsValues = argumentsValues;
    }

    public String getCommandLabel() {
        return commandLabel;
    }

    public String getCommand() {
        return command;
    }

    public CommandSender getSender() {
        return sender;
    }

    public ArgumentValue getArgumentsValue(String key) {
        return argumentsValues.getOrDefault(key, new ArgumentValue(null));
    }

}
