package com.io.yutian.thewarskyblocklib.command;

import com.io.yutian.thewarskyblocklib.command.argument.Argument;
import org.bukkit.command.CommandSender;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.function.Predicate;

public class CommandNode {

    private String name;

    private List<CommandNode> childrens = new ArrayList<>();
    private List<Argument> arguments = new ArrayList<>();

    private List<String> alias = new ArrayList<>();

    private Predicate<CommandSender> commandSenderPredicate = (commandSender -> true);
    private CommandPerformer commandPerformer;

    public CommandNode(String name) {
        this.name = name;
    }

    public CommandNode(String name, String[] alias) {
        this.name = name;
        this.alias = Arrays.asList(alias);
    }

    public CommandNode(String name, List<String> alias) {
        this.name = name;
        this.alias = alias;
    }

    public CommandNode permission(Predicate<CommandSender> commandSenderPredicate) {
        this.commandSenderPredicate = commandSenderPredicate;
        return this;
    }

    public List<String> getAlias() {
        return alias;
    }

    public CommandNode setAlias(List<String> alias) {
        this.alias = alias;
        return this;
    }

    public CommandNode addAilas(String alias) {
        this.alias.add(alias);
        return this;
    }

    public CommandNode addArgument(Argument argument) {
        arguments.add(argument);
        return this;
    }

    public CommandNode addChildren(CommandNode commandNode) {
        this.childrens.add(commandNode);
        return this;
    }

    public List<CommandNode> getChildrens() {
        return childrens;
    }

    public List<Argument> getArguments() {
        return arguments;
    }

    public CommandNode executes(CommandPerformer commandPerformer) {
        this.commandPerformer = commandPerformer;
        return this;
    }

    public CommandPerformer getCommand() {
        return commandPerformer;
    }

    public String getName() {
        return name;
    }

    public static CommandNode node(String name) {
        return new CommandNode(name);
    }

}
