package com.io.yutian.thewarskyblocklib.command;

import com.io.yutian.thewarskyblocklib.command.argument.Argument;
import org.bukkit.command.CommandSender;

import java.util.ArrayList;
import java.util.List;

public abstract class ICommand {

    public static final String PERMISSION_PREFIX = "thewarskyblock.command.";

    private String name;
    private String description;

    private List<CommandNode> commandNodes = new ArrayList<>();
    private List<Argument> arguments = new ArrayList<>();

    public ICommand(String name) {
        this.name = name;
        this.description = null;
    }

    public ICommand(String name, String description) {
        this.name = name;
        this.description = description;
    }

    public boolean hide() {
        return false;
    }

    public void executes(CommandContext commandContext) {
    }

    public boolean emptyExecutes(CommandSender commandSender) {
        return false;
    }

    public boolean hasPermission(CommandSender sender) {
        return sender.isOp() || sender.hasPermission(PERMISSION_PREFIX+name);
    }

    public ICommand addArgument(Argument argument) {
        arguments.add(argument);
        return this;
    }

    public ICommand addCommandNode(CommandNode commandNode) {
        this.commandNodes.add(commandNode);
        return this;
    }

    public List<CommandNode> getCommandNodes() {
        return commandNodes;
    }

    public List<Argument> getArguments() {
        return arguments;
    }

    public String getName() {
        return name;
    }

    public String getDescription() {
        return description;
    }

}
