package com.io.yutian.thewarskyblocklib.config;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.configuration.file.FileConfiguration;

import java.util.List;

public interface ConfigReader<V> {

    ConfigReader<String> STRING = (path, configuration) -> configuration.getString(path);
    ConfigReader<Boolean> BOOLEAN = (path, configuration) -> configuration.getBoolean(path);
    ConfigReader<Integer> INTEGER = (path, configuration) -> configuration.getInt(path);
    ConfigReader<Double> DOUBLE = (path, configuration) -> configuration.getDouble(path);
    ConfigReader<Float> FLOAT = (path, configuration) -> (float) configuration.getDouble(path);
    ConfigReader<Long> LONG = (path, configuration) -> configuration.getLong(path);
    ConfigReader<List<?>> LIST = (path, configuration) -> configuration.getList(path);
    ConfigReader<List<String>> STRING_LIST = (path, configuration) -> configuration.getStringList(path);
    ConfigReader<Location> LOCATION = (path, configuration) -> {
        World world = Bukkit.getWorld(configuration.getString(path+".world"));
        double x = configuration.getDouble(path+".x");
        double y = configuration.getDouble(path+".x");
        double z = configuration.getDouble(path+".x");
        float yaw = (float) configuration.getDouble(path+".yaw");
        float pitch = (float) configuration.getDouble(path+".pitch");
      return new Location(world, x, y, z, yaw, pitch);
    };

    V read(String path, FileConfiguration configuration);

}
