package com.io.yutian.thewarskyblocklib.gui.button;

import com.io.yutian.thewarskyblocklib.nms.item.NMSItemStack;
import com.io.yutian.thewarskyblocklib.nms.nbt.NBTCompound;
import com.io.yutian.thewarskyblocklib.nms.nbt.NBTString;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

import java.util.function.BiConsumer;
import java.util.function.BiPredicate;
import java.util.function.Function;

public class ItemButton extends Button {

    private BiConsumer<Player, ItemStack> clickItemConsumer;

    private Function<ItemStack, ItemStack> putItemFunction;
    private BiPredicate<Player, ItemStack> putPredicate;

    private ItemStack item;

    public ItemButton(ItemStack itemStack) {
        super(itemStack);
        NMSItemStack nmsItemStack = NMSItemStack.build(itemStack);
        NBTCompound nbtCompound = nmsItemStack.getTag();
        nbtCompound.putString("thewarskyblock_meta", "item_button");
        nmsItemStack.setTag(nbtCompound);
        setItemStack(nmsItemStack.getBukkitItemStack());
    }

    public ItemButton setItem(ItemStack item) {
        this.item = item;
        return this;
    }

    public ItemStack getItem() {
        return item;
    }

    public ItemButton itemPredicate(BiPredicate<Player, ItemStack> predicate) {
        this.putPredicate = predicate;
        return this;
    }

    public ItemButton putItem(Function<ItemStack, ItemStack> putItemFunction) {
        this.putItemFunction = putItemFunction;
        return this;
    }

    public boolean isItem() {
        NBTCompound nbtCompound = NMSItemStack.build(item).getTag();
        return nbtCompound.hasKey("thewarskyblock_meta", NBTString.TYPE_ID) && nbtCompound.getString("thewarskyblock_meta").equalsIgnoreCase("item_button");
    }

    public boolean isItem(ItemStack item) {
        NBTCompound nbtCompound = NMSItemStack.build(item).getTag();
        return nbtCompound.hasKey("thewarskyblock_meta", NBTString.TYPE_ID) && nbtCompound.getString("thewarskyblock_meta").equalsIgnoreCase("item_button");
    }

    public ItemButton clickItem(BiConsumer<Player, ItemStack> consumer) {
        this.clickItemConsumer = consumer;
        return this;
    }

    public BiConsumer<Player, ItemStack> getClickItemConsumer() {
        return clickItemConsumer;
    }

    public Function<ItemStack, ItemStack> getPutItemFunction() {
        return putItemFunction;
    }

    public BiPredicate<Player, ItemStack> getPutPredicate() {
        return putPredicate;
    }

}
