package com.io.yutian.thewarskyblocklib.nms.item;

import com.io.yutian.thewarskyblocklib.nms.nbt.NBTBase;
import com.io.yutian.thewarskyblocklib.nms.nbt.NBTCompound;
import net.minecraft.nbt.NBTTagCompound;
import org.bukkit.craftbukkit.v1_18_R2.inventory.CraftItemStack;
import org.bukkit.inventory.ItemStack;

public class NMSItemStack {

    private ItemStack bukkitItemStack;
    private net.minecraft.world.item.ItemStack nmsItemStack;

    public NMSItemStack(ItemStack itemStack) {
        this.bukkitItemStack = itemStack;
        this.nmsItemStack = CraftItemStack.asNMSCopy(itemStack);
    }

    public NBTCompound getTag() {
        NBTTagCompound tag = nmsItemStack.t();
        if (tag == null) {
            tag = new NBTTagCompound();
        }
        return (NBTCompound) NBTBase.as(tag);
    }

    public void setTag(NBTCompound nbtCompound) {
        nmsItemStack.c((NBTTagCompound) NBTCompound.asNMS(nbtCompound));
        bukkitItemStack = CraftItemStack.asBukkitCopy(nmsItemStack);
    }

    public boolean hasNBTCompound(String key) {
        NBTCompound nbtCompound = getTag();
        return nbtCompound.hasKey(key);
    }

    public NBTCompound getNBTCompound(String key) {
        NBTCompound nbtCompound = getTag();
        return nbtCompound.hasKey(key) ? nbtCompound.getCompound(key) : new NBTCompound();
    }

    public ItemStack getBukkitItemStack() {
        return bukkitItemStack;
    }

    public net.minecraft.world.item.ItemStack getNMSItemStack() {
        return nmsItemStack;
    }

    public static NMSItemStack build(ItemStack itemStack) {
        return new NMSItemStack(itemStack);
    }

    public static NMSItemStack build(NBTCompound nbtCompound) {
        net.minecraft.world.item.ItemStack nmsItemStack = net.minecraft.world.item.ItemStack.a((NBTTagCompound) NBTBase.asNMS(nbtCompound));
        return new NMSItemStack(CraftItemStack.asBukkitCopy(nmsItemStack));
    }

}
