package com.io.yutian.thewarskyblocklib.serializa;

import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.json.JSONObject;

import java.lang.reflect.Method;
import java.util.Map;

public class SerializaUtil {

    public static <T extends Serializable> JSONObject serialize(T instance) {
        return instance.toJson();
    }

    public static <T extends Serializable> T deserialize(Class<T> tClass, JSONObject json) {
        try {
            Method method = tClass.getMethod("of", JSONObject.class);
            method.setAccessible(true);
            return (T) method.invoke(null, json);
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static <T extends ConfigSerializable> Map<String, Object> serialize(T instance) {
        return instance.serialize();
    }

    public static <T extends ConfigSerializable> T deserialize(Class<T> tClass, ConfigurationSection section) {
        try {
            Method method = tClass.getMethod("deserialize", ConfigurationSection.class);
            method.setAccessible(true);
            return (T) method.invoke(null, section);
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static <T extends ConfigSerializable> void writeFile(FileConfiguration configuration, T value, String path) {
        Map<String, Object> map = value.serialize();
        for (Map.Entry<String, Object> entry : map.entrySet()) {
            configuration.set(path != null ? path+"."+entry.getKey() : entry.getKey(), entry.getValue());
        }
    }

}
