package com.io.yutian.thewarskyblocklib.util;

import org.bukkit.scoreboard.Objective;
import org.bukkit.scoreboard.Score;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ScoreBoardBuilder {

    private Objective objective;

    private Map<String, Integer> amountMap = new HashMap<>();
    private List<String> lines = new ArrayList<>();

    public ScoreBoardBuilder(Objective objective) {
        this.objective = objective;
    }

    public void add(String line) {
        String s = line;
        int i = amountMap.getOrDefault(s, 0);
        if (i > 0) {
            int j = i + 1;
            for (int l = j; l >= 0; l--) {
                s =  s + " ";
            }
        }
        amountMap.put(line, i+1);
        lines.add(s);
    }

    public void build() {
        int amount = getLines().size();
        int index = amount / 2;
        for (String line : lines) {
            Score score = objective.getScore(line);
            score.setScore(index);
            index--;
        }
    }

    public List<String> getLines() {
        return lines;
    }

    public Objective getObjective() {
        return objective;
    }

}
